
%% Funzione CCF

% Basic_CCF = tag dei basic event CCF
% Beta_f = valore del beta factor
% beta_type = tipo di beta factor che si vuole calcolare (max, average, min) 

function [lam_ccf, Q_ccf, F_ccf, w_ccf, handle_ccf]=CCF_param(model_name,Basic_CCF,Beta_f,beta_type);

% input
model_name;
Basic_CCF;
Beta_f=str2double(Beta_f);
beta_type;


f=find_system(model_name,'MaskType','Basic_Event'); 
f=cell2mat(get_param(f,'Handle'));

% Array cella con i parametri dei Basic event CCF
param_ccf=cell(1,1);
% handle dei basic event CCF
handle_ccf=cell(1,1);

for j=1:length(Basic_CCF)
    
    for h=1:length(f)
        g=f(h);
        
        Tag=string(get_param(g,'tag_ev'));
        if Tag==Basic_CCF{j}
           handle_ccf{j}=get_param(g,'Handle'); 
           
           param_ccf{j,1}=get_param(g,'lam_mttf');     %   |  lambda(t) |
           param_ccf{j,2}=get_param(g,'UnAv');         %   |    Q(t)    |
           param_ccf{j,3}=get_param(g,'UnRe');         %   |    F(t)    |
           param_ccf{j,4}=get_param(g,'f_density');    %   |    w(t)    |
        end
    
    end
end

%% Converto cell array di stringhe in double
s=size(param_ccf);
s=s(2);
for j=1:s
    param_ccf(:,j)=[cellfun(@str2num,param_ccf(1:end,j),'un',0).'];
end
param_ccf=cell2mat(param_ccf);

lam=[];
Q=[];
F=[];
w=[];

lam=param_ccf(:,1);   % Failure rate dei basic events
Q=param_ccf(:,2);     % UnAvailability dei basic events
F=param_ccf(:,3);     % UnReliability dei basic events
w=param_ccf(:,4);     % UnConditional failure density dei basic events


if beta_type==1      % Beta factor(Max) --> Approccio conservativo
    
    lam_ccf=max(lam);
    Q_ccf=max(Q);
    F_ccf=max(F);
    w_ccf=max(w);
    
elseif beta_type==2  % Beta factor(Average) 
    
    lam_ccf=mean(lam);
    Q_ccf=mean(Q);
    F_ccf=mean(F);
    w_ccf=mean(w);
    
elseif beta_type==3  % Beta factor(Min) --> Approccio Ottimistico
    
    lam_ccf=min(lam);
    Q_ccf=min(Q);
    F_ccf=min(F);
    w_ccf=min(w);
    
end

% Parametri del CCF

    lam_ccf=Beta_f*lam_ccf;
    Q_ccf=Beta_f*Q_ccf;
    F_ccf=Beta_f*F_ccf;
    w_ccf=Beta_f*w_ccf;

%% Handle di tipo intero dei Basic CCF
handle_ccf=cell2mat(handle_ccf);

end