function varargout = ControlPanelGui(varargin)
% CONTROLPANELGUI MATLAB code for ControlPanelGui.fig
%      CONTROLPANELGUI, by itself, creates a new CONTROLPANELGUI or raises the existing
%      singleton*.
%
%      H = CONTROLPANELGUI returns the handle to a new CONTROLPANELGUI or the handle to
%      the existing singleton*.
%
%      CONTROLPANELGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CONTROLPANELGUI.M with the given input arguments.
%
%      CONTROLPANELGUI('Property','Value',...) creates a new CONTROLPANELGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before ControlPanelGui_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to ControlPanelGui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help ControlPanelGui

% Last Modified by GUIDE v2.5 06-Jul-2018 14:46:51

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @ControlPanelGui_OpeningFcn, ...
                   'gui_OutputFcn',  @ControlPanelGui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT



%% OPENING FUNCTION    
% --- Executes just before ControlPanelGui is made visible.
function ControlPanelGui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to ControlPanelGui (see VARARGIN)

% Choose default command line output for ControlPanelGui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes ControlPanelGui wait for user response (see UIRESUME)
% uiwait(handles.figure1);


%% Ritorno nome del modello simulink
%% Model Name 
model_name=string(get_param(gcb,'model_sim'));
assignin('base','model_name',model_name);
mod=gcs;
library='FT_library';
library=string(library);

% Scelta del modello
if model_name=="[]" & mod~=library
    
    model_name=gcs;  % Modello Simulink aperto (gcs ritorna il nome del modello simulink aperto)
    set_param(gcb,'model_sim',model_name); % lo faccio apparire di lato nel blocco
    set(handles.edit1,'string',model_name);
elseif model_name~="[]"
    model_name=model_name;
    set_param(gcb,'model_sim',model_name); % lo faccio apparire di lato nel blocco
    set(handles.edit1,'string',model_name);
end
    
%% Ritorno Time mission
dt=string(get_param(gcb,'dt'));
if dt~="[]";
    dt=dt;
    set(handles.edit5,'string',dt);
end


%% Ritorno descrizione "Success Criteria" 
%  Variabile di controllo del campo "Description"
desc=string(get_param(gcb,'Description'));

if isempty(desc)
    % Non fare nulla
    else
    set(handles.edit3,'string',desc);         % Descrizione
end
%% Ritorno la scelta del PopUpMenu del success criteria
SC=get_param(gcb,'SC');
assignin('base','SC',SC);

if SC=='[]'  
   % Do nothing
else
    
    if SC=='Q'   
    % Properties    
    set(handles.success_criteria_menu,'value',1);  
    elseif SC=='F'     
    % Properties
    set(handles.success_criteria_menu,'value',2);   
    elseif SC=='W'    
    % Properties
    set(handles.success_criteria_menu,'value',3);    
    end

end % end "if isempty(SC)


% --- Outputs from this function are returned to the command line.
function varargout = ControlPanelGui_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



%% SET SUCCESS CRITERIA
% --- Executes on button press in pushbutton10.
function pushbutton10_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%% DESCRIZIONE "Success Criteria"

% Prendo il testo che descrive il "Success Criteria" 
desc=string(get(handles.edit3,'String'));
assignin('base','desc',desc);
info_s=join(desc);
assignin('base','info_s',info_s);
% Variabile di controllo del campo " Description"
desc=info_s;
% String cell per "Description" property del Control panel per Success criteria
set_param(gcb,'Description',desc);

%% SELEZIONE "Success Criteria" 
%{

Nel pannello "success criteria" salvo la scelta fatta e con una funzione
vado a settare Q, F, W nella propriet SC in modo che dalla gui del basic
event, nella opening function la GUI riconosca la scelta fatta e imposti i
pannelli di outout in modo da mostrare solo quello che vuole l'utente;

%}

% Pulisco tutte le variabili dal Workspace create in precedenza ( Per pulizia) 
 evalin( 'base', 'clear variables' ); 
%% Model Name 
model_name=get(handles.edit1,'string');
% Scelta del modello
if isempty(model_name)
    model_name=gcs;  % Modello Simulink aperto (gcs ritorna il nome del modello simulink aperto)
else
model_name=model_name;
end
set_param(gcb,'model_sim',model_name);

%% Tipo di componente
pop_comp=get(handles.success_criteria_menu,'value');
if pop_comp==1
      %% Component Type
     SC='Q';
     set_param(gcb,'SC',SC);
     SC_show='UnAvailability_Q(t)';
     set_param(gcb,'SC_show',SC_show);
     assignin('base','SC',SC);
     assignin('base','SC_show',SC_show);
     
elseif pop_comp==2
    SC='F';
    set_param(gcb,'SC',SC);
    SC_show='UnReliability_F(t)';
    set_param(gcb,'SC_show',SC_show);
    assignin('base','SC',SC);
    assignin('base','SC_show',SC_show);
elseif pop_comp==3
    SC='W';
    set_param(gcb,'SC',SC);
    SC_show='Unconditional_failure_density_W(t)';
    set_param(gcb,'SC_show',SC_show);
    assignin('base','SC',SC);
    assignin('base','SC_show',SC_show);
end

% Funzione per settare nei basic event il "Scuccess Criteria" scelto
Set_Success_Criteria(model_name,SC,SC_show)

%% Time mission del sistema
dt=get(handles.edit5,'string');
if isempty(dt)    
    dt="1";
else
dt=string(get(handles.edit5,'string'));
end
set_param(gcb,'dt',dt);  
% Propago la time mission ai Basic event e al Top event
Set_Time_Mission(model_name,dt);


%% START PROPAGATION   << Basic Event + CCF + Intermidiate Event + Top Event >>
% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Pulisco tutte le variabili dal Workspace create in precedenza ( Per pulizia) 
 evalin( 'base', 'clear variables' ); 

%% Model Name 
model_name=get(handles.edit1,'string');
% Scelta del modello
if isempty(model_name)
    model_name=gcs;  % Modello Simulink aperto (gcs ritorna il nome del modello simulink aperto)
else
model_name=model_name;
end
set_param(gcb,'model_sim',model_name);

%% Pulisco il modello cosi che possa sempre propagare 
clean_model(model_name);

%% Propagazione Simbolica Estesa   

% Ciclo "Basic Event" e "CCF"
[f,Ev,BC,gate]=Get_block_BasicEv(model_name); % comprensivo di CCF
% Verifico contenuto variabili
assignin('base','f',f);
assignin('base','Ev',Ev);
assignin('base','BC',BC);
assignin('base','gate',gate);
% Propago la "Tag" dei Basic event 
ForSym_BasicEvs_prop(Ev,BC); 


% Ciclo "Intermidiate Event"
% Propago Intermidiate events 
[full_IntEvs,cicli_int]=ForSym_IntEvs_prop(model_name);
assignin('base','Contatore_int_completi',full_IntEvs);
assignin('base','Cicli_per_il_TOP',cicli_int);

% Ciclo "Top Event"
% Ottengo l'equazione simbolica del TOP EVENT
TOP_ext=ForSym_TopEv(model_name); % Top di tipo scringa 
assignin('base','TOP_ext',TOP_ext);

%% Propagazione Numerica

% Pulisco le description dei Blocchi ~ da Basic e Description e "check_if_full"
clean_description(model_name);
% Propago i "Basic Event"
Propagate2logic_BasicEv(Ev,BC); % Comprensivo di CCF
% Propago Lambda, Q, F negli Intermidiate Event
PropNum_lam_Q_F_Int(Ev,model_name);
% Propago "Intermidiate Event" 
cycle_int(model_name);
% Ottento il TOP EVENT numerico
cycle_Top(model_name);


% verifica se la propagazione  avvenuta con successo controllando gli...
...eventi intermedi
    
[check_int,check_top]=check_propagation(model_name);
assignin('base','check_int',check_int);
assignin('base','check_top',check_top);
% check_int==1 --> tutti gli intermediate sono propagati
% check_int==2 --> non ci sono intermidiate event
% check_top==1 --> le propriet dei blocchi sono state propagate
                   ...correttamente al Top event
if (check_int==1 & check_top==1) | (check_int==2 & check_top==1)
    
    myicon = imread('mark.png');
    h=msgbox('Propagation Completed','Success','custom',myicon);
else
    myicon = imread('X.png');
    h=msgbox('Something Failed','Fail','custom',myicon);
    
end


%% FTA tool to Excel
% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Pulisco tutte le variabili dal Workspace create in precedenza ( Per pulizia) 
 evalin( 'base', 'clear variables' ); 
 
%% Prendo il nome del modello
%% Model Name 
model_name=get(handles.edit1,'string');
assignin('base','model_name',model_name);
% Scelta del modello
if isempty(model_name)
    model_name=gcs;  % Modello Simulink aperto (gcs ritorna il nome del modello simulink aperto)
else
model_name=model_name;
end
set_param(gcb,'model_sim',model_name);


%% Men di dialogo per la "scelta del salvataggio e nome del file" 
% Nome di default
default_name_xlsx={'Template_Simulink-Excel.xlsx'};
% interfaccia di salvataggio
[filename, pathname,indx] = uiputfile(default_name_xlsx,'Fault tree saving path');

% controllo che lo user abbia selezionato un percorso
if pathname~=0 
    
% Nome template simulink excel
def_name='Template_Simulink-Excel.xlsx';
current_folder=pwd;
current_folder=strcat(current_folder,'\');

% Controllo su cartella sorgente
if strcmp(current_folder,pathname) % impedisco di modificare i file della cartella sorgente
                                     ... per mantenere i template inaleterti;    
  f = warndlg('Choose a directory different from the source folder please','Warning');  
else
% Copio il template nella nuova directory
a=pathname;
b=strcat(current_folder,def_name);
copyfile(b,a,'f'); % 'f' override read only

% percorso nuovo\nome predefinito
c=strcat(pathname,def_name);

% Rinomino file
if ~strcmp(filename,def_name)
%  percorso nuovo\nome nuovo
d=strcat(pathname,filename);
movefile(c,d,'f');
s=d;
else
s=c;
end  

%% Info Basic Event 
[Evs_basic,f]=Get_info_BasicEv(model_name);
if isempty(f)
    
    f = warndlg('No basic events have been found','Warning');
else
Evs_basic=string(Evs_basic);
assignin('base','info_BasicEvs',Evs_basic);
%{
    Esempio:

                              <CONSTANT>              <FIXED>
          
    Evs_basic{h,1}      %   | Nome blocco |     %   | Nome blocco | 
    Evs_basic{h,2}      %   |  Modello    |     %   |  Modello    |
    Evs_basic{h,3}      %   | Tag Evento  |     %   | Tag Evento  |
    Evs_basic{h,4}      %   | Componente  |     %   |     []      |
    Evs_basic{h,5}      %   |  lambda(t)  |     %   |  lambda(t)  |
    Evs_basic{h,6}      %   |    mu       |     %   |     []      |
    Evs_basic{h,7}      %   |    dt       |     %   |     []      |
    Evs_basic{h,8}      %   |    test     |     %   |     []      |
    Evs_basic{h,9}      %   |    Q(t)     |     %   |    Q(t)     |
    Evs_basic{h,10}     %   |    F(t)     |     %   |    F(t)     |
    Evs_basic{h,11}     %   |    w(t)     |     %   |    w(t)     |
%}

% Foglio Excel Basic Event 
b_sheet=1;
b_range='A3';
xlswrite(s,Evs_basic,b_sheet,b_range); 

end

%% Info Intermidiate Events 
[Evs_int,f_int]=Get_info_IntermediateEv(model_name);
if isempty(f_int)
    
    f = warndlg('No Intermediate Events have been found','Warning');
else    
    Evs_int=string(Evs_int);
    
% Foglio Excel Intermidiate Event 
i_sheet=2;
i_range='A3';
xlswrite(s,Evs_int,i_sheet,i_range);    
end

%% Info Top Event 
[Evs_top,f_top]=Get_info_TopEv(model_name);
if isempty(f_top)
    
        f = warndlg('No Top Event have been found','Warning');
else   
        Evs_top=string(Evs_top);

% Foglio Excel Top Event 
i_sheet=3;
i_range='A3';
xlswrite(s,Evs_top,i_sheet,i_range); 
end

end

end % l'utente ha annullato o chiuso la finestra di dialogo senza fare nulla





%% Excel to FTA tool
% --- Executes on button press in pushbutton7.
function pushbutton7_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Prendo il success criteria 
SC=get_param(gcb,'SC'); % Vedo il success criteria scelto nel pannello di controllo
assignin('base','SC',SC);
% Prendo il success criteria da mostrare 
SC_show=get_param(gcb,'SC_show'); % Vedo il success criteria scelto nel pannello di controllo
assignin('base','SC_show',SC_show);

% Menu per la creazione del template di default e il caricamento dei basic
...event 
answer = questdlg('Choose an operation:',...
    'Menu',...
    'New FTA template','Load FTA template','New FTA template');


% Handle response
switch answer
    case 'New FTA template'

default_name_xlsx={'Template_Excel-Simulink.xlsx'};
% interfaccia di salvataggio
[filename, pathname,indx] = uiputfile(default_name_xlsx,' Template spreadsheet to FTA tool saving path ');
current_folder=pwd;
current_folder=strcat(current_folder,'\');

if pathname~=0 
% Controllo su cartella sorgente
if strcmp(current_folder,pathname) % impedisco di modificare i file della cartella sorgente
                                     ... per mantenere i template inaleterti;    
  f = warndlg('Choose a directory different from the source folder please','Warning');  
else
%% Copio il template nella nuova directory

% Nome template simulink excel
def_name='Template_Excel-Simulink.xlsx';
a=pathname;
b=strcat(current_folder,def_name);
copyfile(b,a,'f'); % 'f' override read only

%% Rinomino file
% percorso\nome predefinito
if ~strcmp(filename,def_name)
c=strcat(pathname,def_name);
%  percorso\nome nuovo
d=strcat(pathname,filename);
movefile(c,d,'f');
end  

set_param(gcb,'check_template','1');

end % strcmp(current_folder,pathname)
end % pathname~=0

case 'Load FTA template'
 
% Verifico se il nuovo template  stato creato
check=string(get_param(gcb,'check_template'));
       
 if check=="1"   
%% Localizzo il file 
% interfaccia di selezione del file
[FileName,PathName] = uigetfile('*.xlsx','Select the Excel source file');

if PathName~=0
nome_file=FileName;  % nome_file  una variabile di tipo "char" 
path_directory=PathName;
nome_file=strcat(path_directory,nome_file);

% Controllo la cartella sorgente
current_folder=pwd;
current_folder=strcat(current_folder,'\');

if strcmp(current_folder,path_directory) % impedisco di modificare i file della cartella sorgente
                                     ... per mantenere i template inaleterti;    
  f = warndlg('Choose a directory different from the source folder please','Warning'); 

else
%% Function per estrapolare i dati del "Basic Event" dal file excel
% BasicEventData conterr tutte le info dei basic event
[BasicEventData]=excel_to_FTA(nome_file);

if iscell(BasicEventData)

%% Una volta presi i dati creo il modello ex novo con i basic event
% Libreria di default provvisoria
library='FT_library';
%[filename, pathname,indx] = uiputfile(default_name_xlsx,'Fault tree save path');
model_name_default='FTA_Excel';
% creo i basic event in un modello vuoto e dispongo su due righe
crea_modello(model_name_default,library,BasicEventData);
% carico i dati nei basic event
load_data_BasicEvent(model_name_default,BasicEventData,SC,SC_show);

end 

end  % ~strcmp

end   % pathname~=0

 else
     
 helpdlg('Create a new default FTA template please',...
        'Check template');     
 end % check==1
        
end % switch


%% CLEAN MODEL
% --- Executes on button press in pushbutton6.
function pushbutton6_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%% Model Name 
model_name=get(handles.edit1,'string');
% Scelta del modello
if isempty(model_name)
    model_name=gcs;  % Modello Simulink aperto (gcs ritorna il nome del modello simulink aperto)
else
model_name=model_name;
end
set_param(gcb,'model_sim',model_name);


% Finestra di scelta pulizia
choice = questdlg('Completely clean Fault Tree?', ...
	'FT options', ...
	'Yes','No','No');
% Handle response
switch choice
    case 'Yes'
        clean_model_FULL(model_name)
    case 'No'
        

end

%% %% UIContextMen Time mission
% --------------------------------------------------------------------
function default_time_mission_Callback(hObject, eventdata, handles)
% hObject    handle to default_time_mission (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
h=msgbox('if no Time mission input, Time mission value set = 1 [ h ] ','Time mission specification','help');



function edit1_Callback(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit1 as text
%        str2double(get(hObject,'String')) returns contents of edit1 as a double


% --- Executes during object creation, after setting all properties.
function edit1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit3_Callback(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit3 as text
%        str2double(get(hObject,'String')) returns contents of edit3 as a double


% --- Executes during object creation, after setting all properties.
function edit3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in success_criteria_menu.
function success_criteria_menu_Callback(hObject, eventdata, handles)
% hObject    handle to success_criteria_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns success_criteria_menu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from success_criteria_menu


% --- Executes during object creation, after setting all properties.
function success_criteria_menu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to success_criteria_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit4_Callback(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit4 as text
%        str2double(get(hObject,'String')) returns contents of edit4 as a double

% --- Executes during object creation, after setting all properties.
function edit4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit5_Callback(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit5 as text
%        str2double(get(hObject,'String')) returns contents of edit5 as a double


% --- Executes during object creation, after setting all properties.
function edit5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit6_Callback(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit6 as text
%        str2double(get(hObject,'String')) returns contents of edit6 as a double


% --- Executes during object creation, after setting all properties.
function edit6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
