

function TOP_clean=ForSym_TopEv(model)


%% Trovo il Top Event
% Trova i nomi Mask Type di tutti i blocchi che si chiamano "Top_Event" e li mette in un array di celle;
f=find_system(model,'MaskType','Top_Event'); % Handle dei basic events

% Da cell ad array cosi che le handle siano numeri
f=cell2mat(get_param(f,'Handle')); 


for h=1:length(f)
    
    g=f(h);% Handle dell'Intermidiate Event che viene ciclato
    pc=get_param(g,'PortConnectivity'); %  una struttura
       
    %% Prendo la handle del blocco sorgente ( sempre una) 
    Input_block_h=pc(1).SrcBlock;  % Handle Porta logica INPUT 
    
    desc_logic_sub_int=get_param(Input_block_h,'Description');
    desc_logic_sub_int=spezza_tranci(desc_logic_sub_int,char(10));
    
    % inizializzo l'array che conterr stringhe di cut set e tag di eventi
    Sym_Evs={};

    % cell array con i parametri del Basic Ev
    for j=1:length(desc_logic_sub_int)
        
    Sym_Evs(1,j)=desc_logic_sub_int(j,1); % cell array di stringhe con le Tag dei Basic Event
   
    end
    
    % Lunghezza "Sym_Evs"
    size_param_b_c=size(Sym_Evs);
    size_param_b_c=size_param_b_c(2);   
    
    %% Riconoscimento porta logica e lambda, Q, F dell' Intermidiate Event
    check_logic=string(get_param(Input_block_h,'MaskType'));             
    % Cell array simbolico che conterr l mio Cut Set Simbolico
    cut_set={};
    
if check_logic=='AND'
  
     prod={};
     prod=str2sym(Sym_Evs{1});
     
    for i=2:size_param_b_c
  
    prod=times(prod,str2sym(Sym_Evs{i}));
    prod=prod;
    % disp(prod);  
    
    end
    cut_set=prod;
    
elseif check_logic=='OR'
    
     sum={};           
     sum=str2sym(Sym_Evs{1});
     
    for i=2:size_param_b_c
  
    sum=plus(sum,str2sym(Sym_Evs{i}));
    sum=sum;
    % disp(sum);   
    
    end
    cut_set=sum;
    
end
  % Converto Cut Set in stringa
  cut_set=string(cut_set);
   
%% Pulisco l'equazione del TOP 
% Prendo tutti i basic event ed eventuali CCF
[f,Ev,BC,gate]=Get_block_BasicEv(model);
% Prendo solo le tag degli eventi 
Evs=Ev(:,1);

% "cut_set"  la mia equazione del TOP da pulire
% Pulizia del TOP 
TOP_clean=Clean_TOP_Ev(Evs,cut_set);

  %% Setto Cut Set "sym" come propriet dialog box
  set_param(g,'top_eq_full',TOP_clean);
 
  description_int=TOP_clean;
  % Setto la description dell'intermidiate event
  set_param(g,'Description',description_int);
  
end   % End function
