
%%  Note
% BC=block connection type
% f= handle basic event 
% Ev= nome degli enveti dei basic eventi
% BC= handle dei blocchi connessi ai basic event
% gate= porte collegate 

%% Funzione che prende le info dai Basic Event del modello (es. FTA) in uso

function [Ev,f]=Get_info_IntermediateEv(modello)

% Trova i nomi Mask Type di tutti i blocchi che si chiamano Basic Event...
... e li mette in un array di celle; 
f=find_system(modello,'MaskType','Intermediate_Event'); % Handle dei basic events

% Converte il cell array in un array ordinario con elementi tutti dello stesso tipo in modo da...
... contare quanti block Basic Event ci sono; 
    
f=cell2mat(get_param(f,'Handle')); %Prende le handle di tutti i Basic Events (BasicEventBlock, BasicEventBlock1...)
% Inizializzo il vettore che conterr la tag degli eventi
Ev=cell(1,1);
for h=1:length(f)
    g=f(h);% Handle del Basic Event che viene ciclato
    % Nome evento, deve essere un cell perch sono stringhe che possono...
    ...avere lunghezze differenti e non posso metterlo in una matrice, 
     ...perch tutti gli elementi devono avere la stessa lunghezza, 
     ...ma nel nostro caso non sar cosi perch abbiamo a che fare con un "nome di evento";
    Ev{h,1}=get_param(g,'Name');         %   | Nome blocco |      
    Ev{h,2}=get_param(g,'tag_int');      %   | Tag Evento  |
    Ev{h,3}=get_param(g,'lam_int');      %   |  lambda(t)  |
    Ev{h,4}=get_param(g,'Qt');           %   |    Q(t)     |
    Ev{h,5}=get_param(g,'Ft');           %   |    F(t)     |
    Ev{h,6}=get_param(g,'wt');           %   |    w(t)     |
  
end 

end    % End Function 


