
%% Funzione che propaga i valori numerici di Lambda, Q, F degli Intermediate Event
function PropNum_lam_Q_F_Int(Ev,model_name)

Ev=Ev';
size_Ev=size(Ev);
size_Ev=size_Ev(2);
%% Cell array dei Basic Event modificato
% 1) prima colonna conterr le tag di tutti gli eventi in formato stringa
% 2) le altre colonne conterr i valori di lambda, Q, F e W dei Basic Event
...in formato di tipo numerico "num"
Ev_new={};
for j=1:size_Ev
    % la prima cella di ogni vettore colonna contiene Tag 
    % le altre celle a scendere contengono i parametri 
    Ev_new(:,j)=[Ev(1,j) cellfun(@str2num,Ev(2:end,j),'un',0).'];
    
end
    
% Array con le Tag dei Basic Event
Ev_tag(:,1)=Ev_new(1,:);
Ev_tag=Ev_tag';
Ev_new(1,:) = [];

% Converto in tipo "num" la matrice dei Basic Event pulita dalle Tag
Ev_new=cell2mat(Ev_new);
%% matrice di double contenente i lambda, Q, F, w dei Basic Event
size_Ev_new=size(Ev_new);
size_Ev_new=size_Ev_new(2); % prendo il numero di colonne dell'array che contiene i barametri Basic event
    
%% Parametri da sostituire nell'equazione del Cut Set
% inizializzo array che conterranno le propriet dell'evento

% array_lambda_basic=[];
array_Q_basic=[];
array_F_basic=[];
array_w_basic=[];
    
for jj=1:size_Ev_new
%     array_lambda_basic(jj)=Ev_new(1,jj);   % array righe  [LAMBDA]
    array_Q_basic(jj)=Ev_new(2,jj);        % array righe    [Q]
    array_F_basic(jj)=Ev_new(3,jj);        % array righe    [F]
%     array_w_basic(jj)=Ev_new(4,jj);        % array righe    [w]
end


%% Trovo gli intermidiate event 
% Trova i nomi Mask Type di tutti i blocchi che si chiamano "Intermidiate_Event" e li mette in un array di celle;
f=find_system(model_name,'MaskType','Intermediate_Event'); % Handle degli Intermidiate events
% Da cell ad array cosi che le handle siano numeri
f=cell2mat(get_param(f,'Handle')); %Prende le handle di tutti gli Intermidiate Event



%% Ciclo le handle degli intermidiate
for h=1:length(f)
    
    g=f(h);% Handle dell'Intermidiate Event che viene ciclato
    
%% Prendo il Cut set simbolico dell'intermidiate
    cut_set=string(get_param(g,'sym'));
    
    
%{   
%% Calcolo Lambda Cut
cut_set_lambda=[];
cut_set_lambda=cut_set;
% scompatto     
cut_set_lambda = insertAfter(cut_set_lambda,"*"," ");
cut_set_lambda = insertBefore(cut_set_lambda,"*"," ");
cut_set_lambda=strsplit(cut_set_lambda,' ');
% sostituisco
for k=1:length(array_lambda_basic)  
     for j=1:length(cut_set_lambda)         
         if strcmp(Ev_tag{k},cut_set_lambda(j))            
            cut_set_lambda(j)= replace(cut_set_lambda(j),Ev_tag{k},num2str(array_lambda_basic(k)));
         end
     end
end      
% Ricompatto
cut_set_lambda=join(cut_set_lambda,' ');
cut_set_lambda=strrep(cut_set_lambda,' ','');
cut_set_lambda = insertAfter(cut_set_lambda,"+"," ");
cut_set_lambda = insertBefore(cut_set_lambda,"+"," ");
% Execute
lambda_int=eval(cut_set_lambda);
%}

%% Calcolo Q Cut

cut_set_Q=[];
cut_set_Q=cut_set;

% scompatto     
cut_set_Q = insertAfter(cut_set_Q,"*"," ");
cut_set_Q = insertBefore(cut_set_Q,"*"," ");
cut_set_Q = strsplit(cut_set_Q,' ');
% sostituisco
for k=1:length(array_Q_basic)  
     for j=1:length(cut_set_Q)         
         if strcmp(Ev_tag{k},cut_set_Q(j))            
            cut_set_Q(j)= replace(cut_set_Q(j),Ev_tag{k},num2str(array_Q_basic(k)));
         end
     end
end      
% Ricompatto
cut_set_Q = join(cut_set_Q,' ');
cut_set_Q = strrep(cut_set_Q,' ','');
cut_set_Q = insertAfter(cut_set_Q,"+"," ");
cut_set_Q = insertBefore(cut_set_Q,"+"," ");
% Execute        
Q_int=eval(cut_set_Q);

     

%% Calcolo F Cut   
cut_set_F=[];
cut_set_F=cut_set;
% scompatto     
cut_set_F = insertAfter(cut_set_F,"*"," ");
cut_set_F = insertBefore(cut_set_F,"*"," ");
cut_set_F = strsplit(cut_set_F,' ');
% sostituisco
for k=1:length(array_F_basic)  
     for j=1:length(cut_set_F)         
         if strcmp(Ev_tag{k},cut_set_F(j))            
            cut_set_F(j)= replace(cut_set_F(j),Ev_tag{k},num2str(array_F_basic(k)));
         end
     end
end      
% Ricompatto
cut_set_F=join(cut_set_F,' ');
cut_set_F=strrep(cut_set_F,' ','');
cut_set_F = insertAfter(cut_set_F,"+"," ");
cut_set_F = insertBefore(cut_set_F,"+"," ");
% Execute
F_int=eval(cut_set_F);

   
%% Setto Q come propriet dialog box (NOTA)
%{

Per la Unreliability come success criteria  pi preciso usare F=1-e^(-CFI), per la Q e W
 come success criteria faccio la sommatoria e produttoria

%}
%      set_param(g,'lam_int',string(lambda_int));
     set_param(g,'Qt',string(Q_int)); 
     
     a=string(get_param(g,'SC'));
     % Il sucess criteria non  UnReliability ma Q o W 
     if a~="F"
     set_param(g,'Ft',string(F_int)); 
     end
%% Setto la Tag dell'Intermidiate
  tag=string(get_param(g,'Name')); % inserisco una tag dell'intermidiate in base al nome del blocco
  tag=strrep(tag,' ','');
  set_param(g,'tag_int',tag); 
  
end   % Chiudo ciclo "for" degli Intermidiate 


end % End function 