

%% Funzione che pulisce tutti i campi description dai blocchi diversi dai Basic e Description Event

function clean_description(model_name)

%% Cancello da tutti i blocchi con MaskType diversa da "Basic Event" e "Description Event il campo descrizione (per pulizia nel caso in cui ci siano riutilizzi di porte logiche )
% trovo tutti i blocchi del modello di tipo "Block"
% bdroot= << Return name of top-level Simulink system >>
r=find_system(bdroot,'Type','Block');
% prendo la handle di ciascun blocco per indentificarlo
r=get_param(r,'Handle');
% trasformo il cell array in un semplice array
r=cell2mat(r);
% Ciclo le handle dei blocchi e per ogni blocco diverso dal Basic setto "Description" con una riga vuota;
for s=1:length(r)
    
    hh=r(s);   
    ms=get_param(hh,'MaskType');   
    % Se diverso da Basic Event o Description Event, cancella la propriet "Description"
    if strcmp(ms,'Basic_Event') || strcmp(ms,'Description_Ev') || strcmp(ms,'Control_Panel_FTA')    
         % do nothing
    else
         % Setto "Description" con riga vuota
        set_param(hh,'Description','');       
    end    
end

% Trovo gli intermidiate event 
ff=find_system(model_name,'MaskType','Intermediate_Event'); % handle intermidiate event
ff=cell2mat(get_param(ff,'Handle')); % da cell array a handle 
%% Cancello check_if_full
for aa=1:length(ff) 
    l=ff(aa);
    set_param(l,'check_if_full','[]');  
end


end % end function 